using System;
using System.IO;
using System.Web.UI;
using System.Data;
using System.Drawing;

public partial class RadUploadInAjaxifiedGrid_ShowImageCS : Page
{
	const int ThumbnailHeight = 60;
	const int ThumbnailWidth = 60;

	private void StreamOriginalImage(byte[] imageData)
    {
		Response.Clear();
		Response.BinaryWrite(imageData);
		Response.End();
    }
	protected void Page_Load(object sender, EventArgs e)
    {
    	DataView data = (DataView)SqlDataSource1.Select(new DataSourceSelectArguments());
    	
		if (data.Count <= 0) 
			return;
    	
		DataRowView result = data[0];
		byte[] imageData = (byte[]) result["Data"];
    	
		
		if (string.IsNullOrEmpty(Request["thumbnail"]))
		{
			StreamOriginalImage(imageData);
		}
		else
		{
			StreamThumbnailImage(imageData);
		}
    }

	private void StreamThumbnailImage(byte[] imageData)
	{
		Image originalImage = Image.FromStream(new MemoryStream(imageData));
		double ratio = originalImage.Width/(double) originalImage.Height;

		int thumbnailHeight = ThumbnailHeight;
		int thumbnailWidth = ThumbnailWidth;
		
		if (originalImage.Height > originalImage.Width)
			thumbnailHeight = Convert.ToInt32(thumbnailHeight*ratio);
		else
			thumbnailWidth = Convert.ToInt32(thumbnailWidth/ratio);

		using (Bitmap thumbnail = new Bitmap(thumbnailHeight, thumbnailWidth))
		{
			using (Graphics g = Graphics.FromImage(thumbnail))
			{
				g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.HighQualityBicubic;
				g.DrawImage(originalImage, 0, 0, thumbnailHeight, thumbnailWidth);
				
				Response.Clear();
				thumbnail.Save(Response.OutputStream, originalImage.RawFormat);
				Response.End();
			}
		}
	}
}
